package de.intevation.aft;

import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;


import java.sql.SQLException;
import java.sql.ResultSet;

import de.intevation.db.ConnectedStatements;

import org.apache.log4j.Logger;

public class Rivers
{
    private static Logger log = Logger.getLogger(Rivers.class);

    public Rivers() {
    }

    public void sync(SyncContext context) throws SQLException {

        log.info("sync: rivers");

        ConnectedStatements flysStatements = context.getFlysStatements();
        ConnectedStatements aftStatements  = context.getAftStatements();

        Map<String, Integer> flysRivers = new HashMap<String, Integer>();

        ResultSet flysRs = flysStatements
            .getStatement("select.river").executeQuery();

        while (flysRs.next()) {
            Integer id   = flysRs.getInt("id");
            String  name = flysRs.getString("name").toLowerCase();
            flysRivers.put(name, id);
        }

        flysRs.close();

        List<River> commonRivers = new ArrayList<River>();

        ResultSet aftRs = aftStatements
            .getStatement("select.gewaesser").executeQuery();

        while (aftRs.next()) {
            String name = aftRs.getString("NAME");
            Integer id1 = flysRivers.get(name.toLowerCase());
            if (id1 != null) {
                int id2 = aftRs.getInt("GEWAESSER_NR");
                River river = new River(id1, id2, name);
                commonRivers.add(river);
            }
        }

        aftRs.close();

        for (River river: commonRivers) {
            river.sync(context);
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
